// P5.3 P5.2 P1.4 

#include "AI8051U.H"
#include "intrins.h"
#include"stdio.h"

typedef unsigned char u8;
typedef unsigned int u16;
u8 flag_=0;

#define FOSC 40000000UL
#define BRT (65536 - (FOSC / 115200 + 2) / 4)
char buffer[16];
bit busy;
char wptr;
char rptr;

u8 index1 = 0; //
u8 index2 = 2; //
u8 LED1[3];    //
u8 LED2[3];    //
u8 color_table[5][3] = {
    {0xFF, 0x00, 0x00}, // ??
    {0x00, 0xFF, 0x00}, // ??
    {0x00, 0x00, 0xFF}, // ??
    {0xFF, 0xFF, 0x00}, // ??
    {0xFF, 0x00, 0xFF}  // ??
};
#define LED_PIN P15
void delay_us(u16 us);
void delay_ms(u16 ms);
void switch_to_next_color(u8 *LED, u8 index);
void ws2812b_reset();
void send_byte(unsigned char byte);
void Uart2Init();
char putchar(char c);
void Uart2Send(char dat);
void Uart2SendStr(char *p);
void change_color()
{
    ws2812b_reset();
    switch_to_next_color(LED1, index1);
    switch_to_next_color(LED2, index2);

    index1 = (index1 + 1) % 5; // ?????
    index2 = (index2 + 1) % 5; // ?????
    delay_ms(100);
}
void main(void)
{

    P_SW2 = 0X80;
    CKCON = 0X00;
    WTST = 0X00;
    P2M0 = 0X00;
    P2M1 = 0X00;
    P1M0 &= ~0x10;
    P1M1 &= ~0x10;
    P5M0 &= ~0x0c;
    P5M1 &= ~0x0c;
    P4M0 = 0X00;
    P4M1 = 0X00;
    P1M0 |= 0x20;
    P1M1 &= ~0x20;
    P1IM0 &=~0X10;
    P1IM1 &=~0X10;
    P1INTE|= 0x10;
    P5IM0 &=~0x0c;
    P5IM1 &=~0x0c;//?????
    P5INTE|= 0x0c;
    P1INTE|= 0x10;
    Uart2Init();
    Uart2SendStr("Uart Test !\r\n");
    while (1)
    {
        switch (flag_)
        {
        case 1/* constant-expression */:
        change_color();
            Uart2SendStr("p14\n");
            flag_=0;
            break;
        case 2/* constant-expression */:
            Uart2SendStr("p52\n");
            flag_=0;
            break;
            case 3/* constant-expression */:
            Uart2SendStr("p53\n");
            flag_ = 0;
            break;
        default:
            break;
        }
    }
}
void Uart2Isr() interrupt 8
{
    if (S2TI)
    {
        S2TI = 0;
        busy = 0;
    }
    if (S2RI)
    {
        S2RI = 0;
        buffer[wptr++] = S2BUF;
        wptr &= 0x0f;
    }
}
void Uart2Init()
{
    P_SW2 = 0x80;
    S2CFG = 0x01;
    S2CON = 0x50;
    T2L = BRT;
    T2H = BRT >> 8;
    T2x12 = 1;
    T2R = 1;
    wptr = 0x00;
    rptr = 0x00;
    busy = 0;

    P1M0 &= ~0X0C;
    P1M1 &= ~0X0C;
    
    IE2 = 0x01;
    EA = 1;
}
void Uart2Send(char dat)
{
    while (busy)
        ;
    busy = 1;
    S2BUF = dat;
}
void Uart2SendStr(char *p)
{
    while (*p)
    {
        Uart2Send(*p++);
    }
}
char putchar(char c)
{
    Uart2Send(c);
    return c;
}
void common_isr() interrupt 13
{
unsigned char intf;
unsigned char intf_5;
intf = P1INTF;
intf_5 = P5INTF;
    
    if(intf&0x10)
    {
        flag_ = 1;
    }
    if(intf_5&0x08)
    {
        flag_ = 3;

    }
    if(intf_5&0x04)
    {
        flag_ = 2;
    }
    P1INTF&=~0X10;
    P5INTF&=~0X0c;
}
void delay_us(u16 us)
{
    do
    {
        NOP(36);
    } while (us--); //
}
void delay_ms(u16 ms) // unsigned int
{
    do
    {
        delay_us(1000); // ?????????????
    } while (--ms);
}

void switch_to_next_color(u8 *LED, u8 index)
{
    unsigned char i;
    LED[0] = color_table[index][0]; // G
    LED[1] = color_table[index][1]; // R
    LED[2] = color_table[index][2]; // B

    for (i = 0; i < 3; i++)
    {
        send_byte(LED[i]); //
    }
}

void ws2812b_reset()
{
    LED_PIN = 0;
    delay_us(300); //
}
void send_byte(unsigned char byte)
{
    unsigned char i;
    for (i = 0; i < 8; i++)
    {
        if (byte & 0x80)
        {                // ?????? 1
            LED_PIN = 1; // ?1 ????0.3us
            delay_us(1); //
            LED_PIN = 0;
            NOP13();
        }
        else
        {                // ?????? 0
            LED_PIN = 1; // ?0 ????0.3us
            NOP13();     //
            LED_PIN = 0; //
            delay_us(1);
        }
        byte <<= 1; // ?? 1 ?????????
    }
}