#include "AI8051U.h"
#include "intrins.h"
#include "stdio.h"
#define FOSC 40000000UL
#define BRT (65536 - (FOSC / 115200 + 2) / 4)
char buffer[16];
bit busy;
char wptr;
char rptr;

typedef unsigned char u8;
typedef unsigned int u16;
// void delay_us(u16 us)
// {
//     do
//     {
//         NOP(5);
//     } while (us--); // us--需要先对us进行减一次，然后赋值给us,然后判断一次，一共需要4个指令周期，NOP36是36个指令周期，40*25=1000ns=1us
//     // MOV R6,R7 //1个指令周期
//     // DEC R7,#0X01//1个指令周期
//     // CJNE R6,#0X00,C:0X0005//如果发生跳转，就是3个指令周期，正常情况为2个指令周期。
//     //方案2
//     //NOP40();
// }
void delay_ms(u16 ms) // unsigned int
{
    u16 i = 0;
    do
    {
        for(i=0;i<900;++i)//11059200 243即可,40M i=900即可
        NOP40(); // 减少对函数的调用，增加性能
    } while (--ms);
}
void Uart2Isr() interrupt 8
{
    if (S2TI)
    {
        S2TI = 0;
        busy = 0;
    }
    if (S2RI)
    {
        S2RI = 0;
        buffer[wptr++] = S2BUF;
        wptr &= 0x0f;
    }
}
void Uart2Init()
{
    P_SW2 = 0x80;
    S2CFG = 0x01;
    S2CON = 0x50;
    T2L = BRT;
    T2H = BRT >> 8;
    T2x12 = 1;
    T2R = 1;
    wptr = 0x00;
    rptr = 0x00;
    busy = 0;


        P1M0&=~0X0C;
		P1M1&=~0X0C;
    
    IE2 = 0x01;
    EA = 1;
}
void Uart2Send(char dat)
{
    while (busy)
        ;
    busy = 1;
    S2BUF = dat;
}
void Uart2SendStr(char *p)
{
    while (*p)
    {
        Uart2Send(*p++);
    }
}
char putchar(char c)
{
	Uart2Send(c);
	return c;
}
// 主程序
void main()
{
	u16 index=0;
    P_SW2 = 0X80;
    CKCON = 0x00;
    WTST = 0x00;

	//   P1M0&=~0X0C;
	// 	P1M1&=~0X0C;
    Uart2Init();
    // IE2 = 0x01;
    // EA = 1;
    Uart2SendStr("Uart Test !\r\n");
		printf("%d\n",index);
    while (1)
    {
//        if (rptr != wptr)
//        {
//            Uart2Send(buffer[rptr++]);
//            rptr &= 0x0f;
//        }
			for(index=0;index<10;++index)
			{
				printf("Uart Test index=%d!\r\n",index);
        delay_ms(1000);
			}
        
    }
}

// int main()
// {
//     P_SW2 = 0X80;
//     CKCON = 0x00;
//     WTST = 0x00;
//     P0M0 = 0x00;
//     P0M1 = 0x00;
//     P1M0 = 0x00;
//     P1M1 = 0x00;
//     P2M0 = 0x00;
//     P2M1 = 0x00;
//     P3M0 = 0x00;
//     P3M1 = 0x00;
//     P4M0 = 0x00;
//     P4M1 = 0x00;
//     P5M0 = 0x00;
//     P5M1 = 0x00;
//     //
//     RSTCFG |= 0x10;
//     RSTCFG &= ~0x10;
//     //
//     RSTCFG |= 0x40;
//     RSTCFG &= ~0x40;
//     //
//     //
//     //
//     RSTCFG = (RSTCFG & ~0x03) | 0;
//     RSTCFG = (RSTCFG & ~0x03) | 1;
//     RSTCFG = (RSTCFG & ~0x03) | 2;
//     RSTCFG = (RSTCFG & ~0x03) | 3;
//     // 使能访问 XFR,没有冲突不用关闭
//     // 设置外部数据总线速度为最快
//     // 设置程序代码等待参数,
//     // 赋值为 0 可将 CPU 执行程序的速度设置为最快
//     // 设置 P4.7 为复位脚
//     // 设置 P4.7 为普通 I/O 口
//     // 使能低压复位功能
//     // 禁止低压复位
//     // 选择低压复位/检测门槛电压为//选择低压复位/检测门槛电压为//选择低压复位/检测门槛电压为//选择低压复位/检测门槛电压为2.0V
//     while (1)
//         ;
// }